﻿Imports Microsoft.VisualBasic
Imports GenericInterfaces.FRInterfaces

''' <summary>
''' 
''' </summary>
''' <typeparam name="AnyObject"></typeparam>
''' <remarks></remarks>
Public MustInherit Class CollectionClass(Of T As {Class, New})
    Implements ICollectionCommon(Of T)

    Private clnCollectionOfOjects As Collection

    Public Function Add(Optional ByVal oAnyObject As T = Nothing, Optional ByVal sKey As String = "") As T Implements ICollectionCommon(Of T).Add
        Dim objNewMember As T

        If oAnyObject Is Nothing Then
            objNewMember = New T()
        Else
            objNewMember = oAnyObject
        End If
        If sKey.Trim().Length = 0 Then
            clnCollectionOfOjects.Add(objNewMember)
        Else
            clnCollectionOfOjects.Add(objNewMember, sKey)
        End If
        Return objNewMember
    End Function

    Public ReadOnly Property Count() As Long Implements ICollectionCommon(Of T).Count
        Get
            Count = clnCollectionOfOjects.Count
        End Get
    End Property

    Public Function Exists(ByVal oKey As Object) As Boolean Implements ICollectionCommon(Of T).Exists
        If clnCollectionOfOjects(oKey) Is Nothing Then
            Return False
        Else
            Return True
        End If
    End Function

    Default Public ReadOnly Property Item(ByVal oKey As Object) As T Implements ICollectionCommon(Of T).Item
        Get
            Item = clnCollectionOfOjects(oKey)
        End Get
    End Property

    Public Sub Remove(ByVal oKey As Object) Implements ICollectionCommon(Of T).Remove
        clnCollectionOfOjects.Remove(oKey)
    End Sub

    Public Function GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        GetEnumerator = clnCollectionOfOjects.GetEnumerator
    End Function

    Public Sub New()
        clnCollectionOfOjects = New Collection
    End Sub

    Protected Overrides Sub Finalize()
        clnCollectionOfOjects = Nothing
    End Sub
End Class