﻿Imports GenericInterfaces.FRInterfaces

''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class FileInformation
    Implements FRInterfaces.IFileInformation

    Dim stringFileName As String
    Dim enumFileType As FileType
    Dim stringBICForwardingBank As String
    Dim stringBICExecutingBank As String
    Dim stringTimeStamp As String
    Dim objectFileLevelTags As Tags
    Dim objectTransactions As Transactions

    Public Sub New()
        objectFileLevelTags = New Tags()
        objectTransactions = New Transactions()
    End Sub

    Protected Overrides Sub Finalize()
        objectFileLevelTags = Nothing
        objectTransactions = Nothing
        MyBase.Finalize()
    End Sub

    Public ReadOnly Property BICExecutingBank() As String Implements FRInterfaces.IFileInformation.BICExecutingBank
        Get
            BICExecutingBank = stringBICExecutingBank
        End Get
    End Property

    Public ReadOnly Property BICForwardingBank() As String Implements FRInterfaces.IFileInformation.BICForwardingBank
        Get
            BICForwardingBank = stringBICForwardingBank
        End Get
    End Property

    Public ReadOnly Property FileName() As String Implements FRInterfaces.IFileInformation.FileName
        Get
            FileName = stringFileName
        End Get
    End Property

    Public ReadOnly Property FileType() As FileType Implements FRInterfaces.IFileInformation.FileType
        Get
            FileType = enumFileType
        End Get
    End Property

    Public Sub GetFileInfo(ByVal sFileName As String) Implements FRInterfaces.IFileInformation.GetFileInfo
        Dim objectTransaction As Transaction
        Dim objectTag As Tag
        Dim objectTags As CollectionClass(Of Tag)

        stringFileName = sFileName
        enumFileType = FRInterfaces.FileType.frFileTypeUnknown
        objectTags = New Tags()
        objectTag = objectTags.Add()
        objectTag.Tag = ":20:"
        objectTag.TagValue = ":20: Value"
        objectTag = objectTags.Add(sKey:=":30:")
        objectTag.Tag = ":30:"
        objectTag.TagValue = ":30: Value"
        objectTransaction = objectTransactions.Add()
        objectTransaction.Tags = objectTags
        objectFileLevelTags = objectTags
    End Sub

    Public ReadOnly Property GetFileLevelTags() As ICollectionCommon(Of ITag) Implements FRInterfaces.IFileInformation.GetFileLevelTags
        Get
            GetFileLevelTags = objectFileLevelTags
        End Get
    End Property

    Public ReadOnly Property TimeStamp() As String Implements FRInterfaces.IFileInformation.TimeStamp
        Get
            TimeStamp = stringTimeStamp
        End Get
    End Property

    Public ReadOnly Property Transactions() As ICollectionCommon(Of ITransaction) Implements FRInterfaces.IFileInformation.Transactions
        Get
            Transactions = objectTransactions
        End Get
    End Property
End Class

''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class FilesInformation
    Inherits CollectionClass(Of FileInformation)

    Public Sub New()
        MyBase.New()
    End Sub
End Class

''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class Tag
    Implements ITag

    Private stringTagID As String
    Private stringTagValue As String

    Public Sub New()
        stringTagID = ""
        stringTagValue = ""
    End Sub

    Friend Sub New(ByVal sTagID As String)
        stringTagID = sTagID
        stringTagValue = ""
    End Sub

    Friend Sub New(ByVal sTagID As String, ByVal sTagValue As String)
        stringTagID = sTagID
        stringTagValue = sTagValue
    End Sub

    Public Property Tag() As String Implements ITag.Tag
        Get
            Tag = stringTagID
        End Get
        Friend Set(ByVal value As String)
            stringTagID = value
        End Set
    End Property

    Public Property TagValue() As String Implements ITag.TagValue
        Get
            TagValue = stringTagValue
        End Get
        Friend Set(ByVal value As String)
            stringTagValue = value
        End Set
    End Property
End Class

''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class Tags
    Inherits CollectionClass(Of Tag)

    Public Sub New()
        MyBase.New()
    End Sub
End Class

''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class Transaction
    Implements ITransaction

    Dim objectTags As ICollectionCommon(Of ITag)

    Public Property Tags() As ICollectionCommon(Of ITag) Implements ITransaction.Tags
        Get
            Tags = objectTags
        End Get
        Set(ByVal value As ICollectionCommon(Of ITag))
            objectTags = value
        End Set
    End Property
End Class

''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class Transactions
    Inherits CollectionClass(Of Transaction)

    Public Sub New()
        MyBase.New()
    End Sub
End Class